(function(window, undefined){
    'use strict'

    //alert("cobub1");
    var browser = {
        versions: function() {
            var u = navigator.userAgent,
                app = navigator.appVersion;
            return {
                ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/),
                android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1,
                iPhone: u.indexOf('iPhone') > -1 || u.indexOf('Mac') > -1,
                iPad: u.indexOf('iPad') > -1
            };
        } (),
        language: (navigator.browserLanguage || navigator.language).toLowerCase()
    };

    document.body.addEventListener('click',
        function (e) {
            //alert(e.target.tagName);
            var msg = '';
            e = e || window.event;
            var target = e.target || e.srcElement;
            var target2 = window.getParentClikcObj(target);
            var target1 = window.getOnClickByParentObj1(target2, target);
            var actualTarget = target1 ? target1 : target2;
            var xpath = '/' + getElementXPath1(actualTarget).substring(10);
            //alert(xpath);
            var realurl=window.location.href;
            if(realurl.lastIndexOf("#")!=-1&&(realurl.length-1)==realurl.lastIndexOf("#")){
                realurl = realurl.substring(0,realurl.lastIndexOf("#"));
            }
            if(realurl.lastIndexOf("?")!=-1){
                realurl = realurl.substring(0,realurl.lastIndexOf("?"));
            }
            //alert(realurl);
            var callInfoIos = JSON.stringify({"x":xpath, "activity":realurl});

            var callInfoAndroid = '{"activity":"' + realurl + '","x":"' + xpath + '"}';

            if (browser.versions.android) window.JsInject.getEvent(callInfoAndroid);
            if (browser.versions.ios || browser.versions.iPhone || browser.versions.iPad){

                try{
                    tianbai.getCall(callInfoIos);
                }catch(e){}

                try{
                    window.webkit.messageHandlers.tianbai.postMessage(callInfoIos);
                }catch(e){}
            }

    }, true);
    window.getElementIdx1 = function(elt) {
        var count = 1;
        for (var sib = elt.previousSibling; sib; sib = sib.previousSibling) {
            if (sib.nodeType == 1 && sib.tagName == elt.tagName) count++
        }
        return count;
    };
    window.getElementXPath1 = function(elt) {
        var path = '';
        for (; elt && elt.nodeType == 1; elt = elt.parentNode) {
            var idx = getElementIdx1(elt);
            var xname = elt.tagName;
            var id = elt.getAttribute('id');

            if (id) xname += "[@id='"+id+"']";
            else if (idx > 1) xname += '[' + idx + ']';
            path = '/' + xname + path;
        }
        return path;
    };

    window.getQTag1 = function(tar){
        if(tar.tagName.toUpperCase()=="A"||tar.tagName.toUpperCase()=="BUTTON" || tar.tagName.toUpperCase()=="INPUT"
            || tar.tagName.toUpperCase()=="SELECT"||tar.tagName.toUpperCase()=="TEXTAREA"){
            return true;
        } else {
            return false;
        }
    }

    window.getParentClikcObj = function(tar){
        //alert(123);
        var flag2 = window.isOnclickByJquery1(tar);

        if(flag2){
            return tar;
        }else {
            var flag1 = window.getQTag1(tar);
            if (flag1) {
                return tar;
            }
            if ((tar && tar.onclick) || (tar && tar.getAttribute("onclick"))) {
                return tar;
            } else {
                return window.getParentClikcObj(tar.parentNode);
            }
        }
    }

    window.isOnclickByJquery1 = function(tar){
        if(typeof jQuery != "undefined" || typeof $ != "undefined"){
            var $events = $._data( $(tar)[0], "events" );

            if($events && $events["click"] ){
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    window.getOnClickByParentObj1 = function(pObj, tar){
        if(typeof jQuery != "undefined" || typeof $ != "undefined") {
            var cls = null;
            if($._data(pObj,"events") && $._data(pObj, "events").click) {
                var flag = false;
                cls = $._data(pObj, "events").click;
                $.each(cls, function(key, handlerObj){
                    var obj = (pObj.querySelector(""+handlerObj.selector));
                    if(obj==tar){
                        flag = true;
                    }
                });
                if (flag) {
                    return tar;
                } else {
                    if (tar.parentNode && (tar.parentNode != pObj)) {
                        return window.getOnClickByParentObj1(pObj,tar.parentNode);
                    } else {
                        return pObj;
                    }
                }
            } 
        }
    }

}(window));