'use strict'
/*
* 加载完成执行的代码
* */
$razor(document).ready(function () {

    //首页header 登陆下来特效
    $razor(".header_right_3").hover(function () {
        $razor(this).find(".login_two_bg").show();
    }, function () {
        $razor(this).find(".login_two_bg").hide();
    });

    /*控制右下角4个图片点击后的效果*/
    $razor("a[name='icon_a']").bind("click", function () {
        var i = $razor("a[name='icon_a']").index($razor(this));
        $razor(this).addClass("copy_hover");
        $razor("#icon_ul li div").eq(i).stop(true, true).slideDown(600, function () {
            $razor(document).bind("click.global", function () {
                $razor("a[name='icon_a']").eq(i).removeClass("copy_hover");
                $razor("#icon_ul li div").eq(i).stop(true, true).slideUp(500);
                $razor(document).unbind("click.global");
            })
        });
    });

    // 导航更多
    $razor(".menu-dlist dd dt").mouseenter(function () {
        $razor(this).hide().siblings().show();
    });
    $razor(".menu-dlist dd dl").mouseleave(function () {
        $razor(this).children().hide().eq(0).show();
    });

    // banner
    $razor(".banner_main").slide({
        titCell: ".num ul",
        mainCell: ".banner_box",
        effect: "fold",
        autoPlay: true,
        delayTime: 600,
        autoPage: true
    });

    // 导航显示特效
    $razor(".nav ul li").hover(function () {
        $razor(this).find(".nav_a").addClass("nav_a_se").next(".menuWrap").show().parents("li").siblings("li").find(".nav_a").removeClass("nav_a_se");

    }, function () {
        $razor(this).find(".nav_a").removeClass("nav_a_se").next(".menuWrap").hide();
    });

    // 导航宽度自适应
    var nav_width = $razor(".main").width();
    $razor(".menuWrap").css("width", nav_width);

    window.onresize = function () {
        var nav_width = $razor(".main").width();
        $razor(".menuWrap").css("width", nav_width);
    };

    // 响应式关闭菜单
    $razor(".main_pad_menu_bg").click(function () {
        $razor(".pad_nav,.main_pad_menu_bg").hide(100);
        $razor(".main").animate({"right": "0px"}, {duration: 100, complete: "", easing: "easeInOutCubic"});
        $razor('.nav_2').removeClass('nav_2_current')
    });

    // 响应式显示菜单
    $razor(".nav_2").click(function () {
        var nav_width2 = $razor(document).height();
        $razor(".main_pad_menu_bg").css("height", nav_width2);
        $razor(".pad_nav,.main_pad_menu_bg").show(300);
        $razor(".main").css({"position": "absolute"})
        $razor(".main").animate({"right": "200px"}, {duration: 300, complete: "", easing: "easeInOutCubic"});
        $razor('.nav_2').addClass('nav_2_current')
        if (!($razor('#search_button_header').is(':hidden'))) {
            $razor(".header_right_02").removeClass("header_right_02_current");
            if (document.body.scrollWidth <= 678) {
                $razor("#search_button_header").stop(true, true).slideUp(1);
            }
        }
    });

    $razor(".fontbold").parents("li").click(function () {
        if (($razor('.header_right_2').is(':hidden'))) {

            if ($razor(this).siblings("li").is(":hidden")) {
                $razor(this).parent('ul').addClass("foot_ul_open");
                $razor(this).siblings("li").show();
            }
            else {
                $razor(this).parent('ul').removeClass("foot_ul_open");
                $razor(this).siblings("li").attr("style", "");
            }
        }
    });

    var nums = 0
    $razor('.mobile_bank_tog .right').click(function (e) {
        nums++;
        if (nums > 2) {
            nums = 0
        }
        $razor('.mobile_bank_tog_down .center').stop().animate({left: nums * -972}, 1000)
    });
    $razor('.mobile_bank_tog .left').click(function (e) {
        nums--;
        if (nums < 0) {
            nums = 2
        }
        $razor('.mobile_bank_tog_down .center').stop().animate({left: nums * -972}, 1000)
    });

    //电子银行tab ICON切换
    var $div_li_he_2 = $razor("div.mobile_bank_tab_title ul li");
    $div_li_he_2.click(function () {
        $razor(this).addClass("sel_tab").siblings("li").removeClass("sel_tab");
        var index_he_2 = $div_li_he_2.index(this);
        $razor("div.mobile_bank_tab_main > div").eq(index_he_2).show().siblings().hide(); //隐藏其他几个同辈的<div>元素
    });


    // 列表页的 轮播图


    // 详情页-----------------储蓄存款---------------------办理渠道滑上和离开效果
    $razor('.chuxu_con .right .chuxu_down ul li ').mouseover(function () {
        $razor(this).find('.chuxu_downimg1').hide().siblings('.chuxu_downimg2').show()
    });

    $razor('.chuxu_con .right .chuxu_down ul li ').mouseout(function () {
        $razor(this).find('.chuxu_downimg1').show().siblings('.chuxu_downimg2').hide()
    });

    // 储蓄里的存款左侧点击效果
    $razor('.chuxu_con .left ul li').click(function () {
        $razor(this).children().eq(0).addClass('current')
        $razor(this).siblings().children('a').removeClass('current')
        $razor(this).find('div').show();
        $razor(this).siblings('li').find('div').hide()
    });

    // 储蓄里的存款中间滑上效果
    $razor(".chuxu_con .center .up .li01 ").hover(function () {
        $razor(".up_p").stop().toggle(500);
    });

    /*
     *author R.W
     *index page head seaching
     */
    $razor(".search_text").focus(function () {
        var $textValue = $razor(".search_text").val();
        if ($textValue == "请输入关键字") {
            $razor(".search_text").val("");
        }
    });

    $razor(".search_text").keydown(function (e) {
        var textValue = $razor.trim($razor(".search_text").val());
        if (e.keyCode == 13) {
            if (textValue == "请输入关键字") {
                $razor(".search_text").val("");
            } else if (textValue == "") {
                alert("请输入关键字");
                $razor(".search_text").val("");
            } else {
                var searchWord = textValue.replace(' ', ''); //取除输入框中输入的空格并且赋值给searchWord
                window.location = '/cs/Satellite?c=Page&cid=1375342064713&pagename=cmbc%2FPage%2FTP_Sousuolayout&rendermode=preview&keyword=' + searchWord + '&thisPage=1';
            }
        }
    });

    $razor(".search_text").blur(function () {
        var $textValue = $razor.trim($razor(".search_text").val());
        if ($textValue == "") {
            $razor(".search_text").val("请输入关键字");
        }
    });

    $razor(".search_button").click(function () {
        var textValue = $razor.trim($razor(".search_text").val());
        if (textValue == "请输入关键字") {
            $razor(".search_text").val("");
            $razor(".search_text").focus();
        } else if (textValue == "") {
            alert("请输入关键字");
            $razor(".search_text").val("");
            $razor(".search_text").focus();
        } else {
            var searchWord = textValue.replace(' ', ''); //取除输入框中输入的空格并且赋值给searchWord
            window.location = '/cs/Satellite?c=Page&cid=1375342064713&pagename=cmbc%2FPage%2FTP_Sousuolayout&rendermode=preview&keyword=' + searchWord + '&thisPage=1';
        }
    });
});

/*
* pad导航
* */
$razor(function () {

    // 事件绑定1
    $razor('.pad_nav .nav_pad_span').click(function () {
        if ($razor(this).parent('li').siblings('li').is(':hidden')) {
            $razor(this).parent('li').addClass('nav_current')
        }
        else {
            $razor(this).parent('li').removeClass('nav_current')
        }
        $razor(this).parent('li').siblings('li').toggle().end().parent('ul').siblings().find('.phone,.phone>ul').hide();
        //alert('ok')
        $razor(this).parent('li').parent('ul').siblings().find('span').parents('li').removeClass('nav_current')
        $razor(this).parent('li').parent('ul').find('.phone ').removeClass('nav_current_list')
    });

    // 事件绑定2
    $razor('.pad_nav .phone .a01').click(function () {
        if ($razor(this).siblings('ul').is(':hidden')) {
            $razor(this).parent('li').addClass('nav_current_list')
        }
        else {
            $razor(this).parent('li').removeClass('nav_current_list')
        }
        $razor(this).siblings('ul').toggle();
        $razor(this).parent('.phone').siblings('li').find('ul').hide()
        $razor(this).parent('.phone').siblings('li').find('.a01').removeClass('nav_current_list')
    });

    // 事件绑定3
    $razor(".phone ul li dt").mouseenter(function () {
        $razor(this).hide().siblings().show();
    });

    // 事件绑定4
    $razor(".phone ul li dl").mouseleave(function () {
        $razor(this).children().hide().eq(0).show();
    });

    // 手机搜索
    if ($razor('.pad_nav').is(':hidden')) {
        $razor(".header_right_02").bind("click", function () {
            //alert('ok')
            $razor(this).addClass("header_right_02_current");
            $razor("#search_button_header").stop(true, true).slideDown(1, function () {
                $razor('.header_right_02').bind("click.global", function () {
                    $razor(".header_right_02").removeClass("header_right_02_current");
                    $razor("#search_button_header").stop(true, true).slideUp(1);
                    $razor('.header_right_02').unbind("click.global");
                })
            });
        });
    }

    // 卢新利 1.6号调整banner图自动轮播轮播
    var num = 0;
    var timer = null;

    $razor('.personal_banner ol li').mouseover(function (e) {
        $razor(this).addClass('current').siblings().removeClass('current')
        var myindex = $razor(this).index()
        //-----------------以上角标------------------以下图片-------------------
        $razor('.personal_banner ul li').eq(myindex).hide().stop().fadeIn(500).siblings().hide();
        num = myindex
    });

    function autoplay() {
        num++;
        if (num > 2) {
            num = 0
        }

        $razor('.personal_banner ol li').eq(num).addClass('current').siblings().removeClass('current')
        //-----------------以上角标------------------以下图片-------------------
        $razor('.personal_banner ul li').eq(num).hide().stop().fadeIn(500).siblings().hide();
    }

    timer = setInterval(autoplay, 6000)

    $razor('.personal_banner').mouseover(function (e) {
        clearInterval(timer)
    });
    $razor('.personal_banner').mouseout(function (e) {
        clearInterval(timer)
        timer = setInterval(autoplay, 6000)
    });


});